import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbMysqlUserConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#authentication_plugin MdbMysqlUser#authentication_plugin}
    */
    readonly authenticationPlugin?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#cluster_id MdbMysqlUser#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#global_permissions MdbMysqlUser#global_permissions}
    */
    readonly globalPermissions?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#id MdbMysqlUser#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#name MdbMysqlUser#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#password MdbMysqlUser#password}
    */
    readonly password: string;
    /**
    * connection_limits block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#connection_limits MdbMysqlUser#connection_limits}
    */
    readonly connectionLimits?: MdbMysqlUserConnectionLimits;
    /**
    * permission block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#permission MdbMysqlUser#permission}
    */
    readonly permission?: MdbMysqlUserPermission[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#timeouts MdbMysqlUser#timeouts}
    */
    readonly timeouts?: MdbMysqlUserTimeouts;
}
export interface MdbMysqlUserConnectionLimits {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#max_connections_per_hour MdbMysqlUser#max_connections_per_hour}
    */
    readonly maxConnectionsPerHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#max_questions_per_hour MdbMysqlUser#max_questions_per_hour}
    */
    readonly maxQuestionsPerHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#max_updates_per_hour MdbMysqlUser#max_updates_per_hour}
    */
    readonly maxUpdatesPerHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#max_user_connections MdbMysqlUser#max_user_connections}
    */
    readonly maxUserConnections?: number;
}
export declare function mdbMysqlUserConnectionLimitsToTerraform(struct?: MdbMysqlUserConnectionLimitsOutputReference | MdbMysqlUserConnectionLimits): any;
export declare class MdbMysqlUserConnectionLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlUserConnectionLimits | undefined;
    set internalValue(value: MdbMysqlUserConnectionLimits | undefined);
    private _maxConnectionsPerHour?;
    get maxConnectionsPerHour(): number;
    set maxConnectionsPerHour(value: number);
    resetMaxConnectionsPerHour(): void;
    get maxConnectionsPerHourInput(): number | undefined;
    private _maxQuestionsPerHour?;
    get maxQuestionsPerHour(): number;
    set maxQuestionsPerHour(value: number);
    resetMaxQuestionsPerHour(): void;
    get maxQuestionsPerHourInput(): number | undefined;
    private _maxUpdatesPerHour?;
    get maxUpdatesPerHour(): number;
    set maxUpdatesPerHour(value: number);
    resetMaxUpdatesPerHour(): void;
    get maxUpdatesPerHourInput(): number | undefined;
    private _maxUserConnections?;
    get maxUserConnections(): number;
    set maxUserConnections(value: number);
    resetMaxUserConnections(): void;
    get maxUserConnectionsInput(): number | undefined;
}
export interface MdbMysqlUserPermission {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#database_name MdbMysqlUser#database_name}
    */
    readonly databaseName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#roles MdbMysqlUser#roles}
    */
    readonly roles?: string[];
}
export declare function mdbMysqlUserPermissionToTerraform(struct?: MdbMysqlUserPermission | cdktf.IResolvable): any;
export declare class MdbMysqlUserPermissionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): MdbMysqlUserPermission | cdktf.IResolvable | undefined;
    set internalValue(value: MdbMysqlUserPermission | cdktf.IResolvable | undefined);
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    get databaseNameInput(): string | undefined;
    private _roles?;
    get roles(): string[];
    set roles(value: string[]);
    resetRoles(): void;
    get rolesInput(): string[] | undefined;
}
export declare class MdbMysqlUserPermissionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: MdbMysqlUserPermission[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): MdbMysqlUserPermissionOutputReference;
}
export interface MdbMysqlUserTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#create MdbMysqlUser#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#delete MdbMysqlUser#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#read MdbMysqlUser#read}
    */
    readonly read?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user#update MdbMysqlUser#update}
    */
    readonly update?: string;
}
export declare function mdbMysqlUserTimeoutsToTerraform(struct?: MdbMysqlUserTimeoutsOutputReference | MdbMysqlUserTimeouts | cdktf.IResolvable): any;
export declare class MdbMysqlUserTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbMysqlUserTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: MdbMysqlUserTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _read?;
    get read(): string;
    set read(value: string);
    resetRead(): void;
    get readInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user yandex_mdb_mysql_user}
*/
export declare class MdbMysqlUser extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_mysql_user";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_mysql_user yandex_mdb_mysql_user} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbMysqlUserConfig
    */
    constructor(scope: Construct, id: string, config: MdbMysqlUserConfig);
    private _authenticationPlugin?;
    get authenticationPlugin(): string;
    set authenticationPlugin(value: string);
    resetAuthenticationPlugin(): void;
    get authenticationPluginInput(): string | undefined;
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    private _globalPermissions?;
    get globalPermissions(): string[];
    set globalPermissions(value: string[]);
    resetGlobalPermissions(): void;
    get globalPermissionsInput(): string[] | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _password?;
    get password(): string;
    set password(value: string);
    get passwordInput(): string | undefined;
    private _connectionLimits;
    get connectionLimits(): MdbMysqlUserConnectionLimitsOutputReference;
    putConnectionLimits(value: MdbMysqlUserConnectionLimits): void;
    resetConnectionLimits(): void;
    get connectionLimitsInput(): MdbMysqlUserConnectionLimits | undefined;
    private _permission;
    get permission(): MdbMysqlUserPermissionList;
    putPermission(value: MdbMysqlUserPermission[] | cdktf.IResolvable): void;
    resetPermission(): void;
    get permissionInput(): cdktf.IResolvable | MdbMysqlUserPermission[] | undefined;
    private _timeouts;
    get timeouts(): MdbMysqlUserTimeoutsOutputReference;
    putTimeouts(value: MdbMysqlUserTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | MdbMysqlUserTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
